# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetLocationsResult',
    'AwaitableGetLocationsResult',
    'get_locations',
    'get_locations_output',
]

@pulumi.output_type
class GetLocationsResult:
    """
    A collection of values returned by getLocations.
    """
    def __init__(__self__, filters=None, id=None, limit=None, locations=None, tags=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if limit and not isinstance(limit, int):
            raise TypeError("Expected argument 'limit' to be a int")
        pulumi.set(__self__, "limit", limit)
        if locations and not isinstance(locations, list):
            raise TypeError("Expected argument 'locations' to be a list")
        pulumi.set(__self__, "locations", locations)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetLocationsFilterResult']]:
        """
        A list of filter to apply to the API query when requesting locations.
        """
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def limit(self) -> Optional[int]:
        """
        The limit of objects to return from the API lookup. Defaults to `0`.
        """
        return pulumi.get(self, "limit")

    @property
    @pulumi.getter
    def locations(self) -> Sequence['outputs.GetLocationsLocationResult']:
        return pulumi.get(self, "locations")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence[str]]:
        """
        A list of tags to filter on.
        """
        return pulumi.get(self, "tags")


class AwaitableGetLocationsResult(GetLocationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLocationsResult(
            filters=self.filters,
            id=self.id,
            limit=self.limit,
            locations=self.locations,
            tags=self.tags)


def get_locations(filters: Optional[Sequence[pulumi.InputType['GetLocationsFilterArgs']]] = None,
                  limit: Optional[int] = None,
                  tags: Optional[Sequence[str]] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLocationsResult:
    """
    Use this data source to access information about an existing resource.

    :param Sequence[pulumi.InputType['GetLocationsFilterArgs']] filters: A list of filter to apply to the API query when requesting locations.
    :param int limit: The limit of objects to return from the API lookup. Defaults to `0`.
    :param Sequence[str] tags: A list of tags to filter on.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['limit'] = limit
    __args__['tags'] = tags
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('netbox:index/getLocations:getLocations', __args__, opts=opts, typ=GetLocationsResult).value

    return AwaitableGetLocationsResult(
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        limit=pulumi.get(__ret__, 'limit'),
        locations=pulumi.get(__ret__, 'locations'),
        tags=pulumi.get(__ret__, 'tags'))


@_utilities.lift_output_func(get_locations)
def get_locations_output(filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetLocationsFilterArgs']]]]] = None,
                         limit: Optional[pulumi.Input[Optional[int]]] = None,
                         tags: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetLocationsResult]:
    """
    Use this data source to access information about an existing resource.

    :param Sequence[pulumi.InputType['GetLocationsFilterArgs']] filters: A list of filter to apply to the API query when requesting locations.
    :param int limit: The limit of objects to return from the API lookup. Defaults to `0`.
    :param Sequence[str] tags: A list of tags to filter on.
    """
    ...
