# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetSiteGroupResult',
    'AwaitableGetSiteGroupResult',
    'get_site_group',
    'get_site_group_output',
]

@pulumi.output_type
class GetSiteGroupResult:
    """
    A collection of values returned by getSiteGroup.
    """
    def __init__(__self__, description=None, id=None, name=None, slug=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if slug and not isinstance(slug, str):
            raise TypeError("Expected argument 'slug' to be a str")
        pulumi.set(__self__, "slug", slug)

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        At least one of `name` or `slug` must be given.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def slug(self) -> str:
        """
        At least one of `name` or `slug` must be given.
        """
        return pulumi.get(self, "slug")


class AwaitableGetSiteGroupResult(GetSiteGroupResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSiteGroupResult(
            description=self.description,
            id=self.id,
            name=self.name,
            slug=self.slug)


def get_site_group(name: Optional[str] = None,
                   slug: Optional[str] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSiteGroupResult:
    """
    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_netbox as netbox

    get_by_name = netbox.get_site_group(name="example-sitegroup-1")
    get_by_slug = netbox.get_site_group(slug="sitegrp")
    ```
    <!--End PulumiCodeChooser -->


    :param str name: At least one of `name` or `slug` must be given.
    :param str slug: At least one of `name` or `slug` must be given.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['slug'] = slug
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('netbox:index/getSiteGroup:getSiteGroup', __args__, opts=opts, typ=GetSiteGroupResult).value

    return AwaitableGetSiteGroupResult(
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        slug=pulumi.get(__ret__, 'slug'))


@_utilities.lift_output_func(get_site_group)
def get_site_group_output(name: Optional[pulumi.Input[Optional[str]]] = None,
                          slug: Optional[pulumi.Input[Optional[str]]] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSiteGroupResult]:
    """
    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_netbox as netbox

    get_by_name = netbox.get_site_group(name="example-sitegroup-1")
    get_by_slug = netbox.get_site_group(slug="sitegrp")
    ```
    <!--End PulumiCodeChooser -->


    :param str name: At least one of `name` or `slug` must be given.
    :param str slug: At least one of `name` or `slug` must be given.
    """
    ...
