# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetVlanResult',
    'AwaitableGetVlanResult',
    'get_vlan',
    'get_vlan_output',
]

@pulumi.output_type
class GetVlanResult:
    """
    A collection of values returned by getVlan.
    """
    def __init__(__self__, description=None, group_id=None, id=None, name=None, role=None, site=None, status=None, tenant=None, vid=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if group_id and not isinstance(group_id, int):
            raise TypeError("Expected argument 'group_id' to be a int")
        pulumi.set(__self__, "group_id", group_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if role and not isinstance(role, int):
            raise TypeError("Expected argument 'role' to be a int")
        pulumi.set(__self__, "role", role)
        if site and not isinstance(site, int):
            raise TypeError("Expected argument 'site' to be a int")
        pulumi.set(__self__, "site", site)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)
        if tenant and not isinstance(tenant, int):
            raise TypeError("Expected argument 'tenant' to be a int")
        pulumi.set(__self__, "tenant", tenant)
        if vid and not isinstance(vid, int):
            raise TypeError("Expected argument 'vid' to be a int")
        pulumi.set(__self__, "vid", vid)

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> int:
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def role(self) -> int:
        return pulumi.get(self, "role")

    @property
    @pulumi.getter
    def site(self) -> int:
        return pulumi.get(self, "site")

    @property
    @pulumi.getter
    def status(self) -> str:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tenant(self) -> int:
        return pulumi.get(self, "tenant")

    @property
    @pulumi.getter
    def vid(self) -> Optional[int]:
        return pulumi.get(self, "vid")


class AwaitableGetVlanResult(GetVlanResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVlanResult(
            description=self.description,
            group_id=self.group_id,
            id=self.id,
            name=self.name,
            role=self.role,
            site=self.site,
            status=self.status,
            tenant=self.tenant,
            vid=self.vid)


def get_vlan(group_id: Optional[int] = None,
             name: Optional[str] = None,
             role: Optional[int] = None,
             tenant: Optional[int] = None,
             vid: Optional[int] = None,
             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVlanResult:
    """
    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_netbox as netbox

    vlan1 = netbox.get_vlan(name="vlan-1")
    vlan2 = netbox.get_vlan(vid=1234,
        role=netbox_ipam_role["example"]["id"])
    vlan3 = netbox.get_vlan(name="vlan-3",
        tenant=netbox_tenant["example"]["id"])
    ```
    <!--End PulumiCodeChooser -->
    """
    __args__ = dict()
    __args__['groupId'] = group_id
    __args__['name'] = name
    __args__['role'] = role
    __args__['tenant'] = tenant
    __args__['vid'] = vid
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('netbox:index/getVlan:getVlan', __args__, opts=opts, typ=GetVlanResult).value

    return AwaitableGetVlanResult(
        description=pulumi.get(__ret__, 'description'),
        group_id=pulumi.get(__ret__, 'group_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        role=pulumi.get(__ret__, 'role'),
        site=pulumi.get(__ret__, 'site'),
        status=pulumi.get(__ret__, 'status'),
        tenant=pulumi.get(__ret__, 'tenant'),
        vid=pulumi.get(__ret__, 'vid'))


@_utilities.lift_output_func(get_vlan)
def get_vlan_output(group_id: Optional[pulumi.Input[Optional[int]]] = None,
                    name: Optional[pulumi.Input[Optional[str]]] = None,
                    role: Optional[pulumi.Input[Optional[int]]] = None,
                    tenant: Optional[pulumi.Input[Optional[int]]] = None,
                    vid: Optional[pulumi.Input[Optional[int]]] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetVlanResult]:
    """
    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_netbox as netbox

    vlan1 = netbox.get_vlan(name="vlan-1")
    vlan2 = netbox.get_vlan(vid=1234,
        role=netbox_ipam_role["example"]["id"])
    vlan3 = netbox.get_vlan(name="vlan-3",
        tenant=netbox_tenant["example"]["id"])
    ```
    <!--End PulumiCodeChooser -->
    """
    ...
